﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Public Class frmLegendProps
   Public Property Legend As CustomLegendLayer
   Public Property PageLayout As WinformsMap
   Public Sub New(oForm As Form, oPageLayout As WinformsMap)

      ' This call is required by the designer.
      InitializeComponent()

      ' Add any initialization after the InitializeComponent() call.
      'Me.SetTopLevel(False)
      Me.Owner = oForm
      PageLayout = oPageLayout
   End Sub
   Private Function mGetPrinterOverlay() As PrinterInteractiveOverLay
      For Each oPrinterOverlay In PageLayout.InteractiveOverlays
         If TypeOf oPrinterOverlay Is PrinterInteractiveOverLay Then
            Return CType(oPrinterOverlay, PrinterInteractiveOverLay)
         End If
      Next oPrinterOverlay
      Return Nothing
   End Function

   Private Sub mAddLegend()
      Dim moPrinterOverlay As PrinterInteractiveOverLay = mGetPrinterOverlay()
      Dim dLegendItemWidth As Single = CSng(txtLegendItemWidth.Text)
      Dim dImageWidth As Single = CSng(txtImageWidth.Text)
      Dim dLegendItemHeight As Single = CSng(txtLegendItemHeight.Text)
      Dim dLegendWidth As Single = CSng(txtLegendWidth.Text)
      Dim dLegendheight As Single = CSng(txtLegendHeight.Text)
      Dim oTitle As LegendItem
      Dim oLegendItem As LegendItem

      '***** Create the LegendPrinterLayer and add the LegendItems.
      Legend = New CustomLegendLayer()

      Legend.BackgroundMask = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.White, GeoColor.SimpleColors.Black, 1)

      '***** Create a legend item for the title.
      oTitle = New LegendItem()
      mSetLegendItemProps(oTitle, "Map Legend", True)

      oTitle.TextStyle = New TextStyle("Map Legend",
                                      New GeoFont("Arial", CInt(txtTitleFontSize.Text), DrawingFontStyles.Bold),
                                      New GeoSolidBrush(GeoColor.SimpleColors.Black))
      Legend.Title = oTitle

      Dim dPix As Double = CreateGraphics.DpiX

      Legend.Height = dLegendheight
      Legend.Width = dLegendWidth


      Legend.LegendItems.Clear()
      For Each oItem In lstItems.Items
         oLegendItem = New LegendItem
         mSetLegendItemProps(oLegendItem, oItem.ToString)
         Legend.LegendItems.Add("LegendItem_" & (Legend.LegendItems.Count + 1).ToString, oLegendItem)
      Next oItem

      moPrinterOverlay = mGetPrinterOverlay()

      If moPrinterOverlay.PrinterLayers.Contains("Legend") Then
         moPrinterOverlay.PrinterLayers.Remove("Legend")
      End If
      moPrinterOverlay.PrinterLayers.Add("Legend", Legend)

      'dLegendWidth = mGetLegendWidth(Legend)

      'Legend.Title.ImageHeight = dImageWidth
      'Legend.Title.ImageWidth = dImageWidth
      'Legend.Title.Height = dLegendItemHeight

      For Each oLegendItem In Legend.LegendItems
         oLegendItem.Height = dLegendItemHeight
         oLegendItem.ImageWidth = dImageWidth
         oLegendItem.ImageHeight = dImageWidth
      Next oLegendItem

      'dLegendheight = mGetLegendHeight(Legend)

      Legend.Height = dLegendheight
      Legend.Width = dLegendWidth

      Legend.ResizeMode = PrinterResizeMode.Resizable
      Legend.SetPosition(dLegendWidth / dPix, dLegendheight / dPix, New PointShape(-2, -3.5), PrintingUnit.Inch)

      Legend.ContentResizeMode = LegendContentResizeMode.Fixed


      PageLayout.Refresh()
      Close()

   End Sub
   Private Sub mSetLegendItemProps(oLegendItem As LegendItem, sText As String, Optional bTitle As Boolean = False)
      With oLegendItem
         .Height = CSng(txtLegendItemHeight.Text)
         .Width = CSng(txtLegendItemWidth.Text)

         .LeftPadding = CSng(txtLeftPadding.Text)
         .RightPadding = CSng(txtRightPadding.Text)
         .TopPadding = CSng(txtTopPadding.Text)
         .BottomPadding = CSng(txtBottomPadding.Text)

         If bTitle Then
            .ImageHeight = 0
            .ImageWidth = 0
            .ImageLeftPadding = 0
            .ImageRightPadding = 0
            .ImageTopPadding = 0
            .ImageBottomPadding = 0
         Else
            .ImageHeight = CSng(txtImageHeight.Text)
            .ImageWidth = CSng(txtImageWidth.Text)
            .ImageLeftPadding = CSng(txtImageLeftPadding.Text)
            .ImageRightPadding = CSng(txtImageRightPaddint.Text)
            .ImageTopPadding = CSng(txtImageTopPadding.Text)
            .ImageBottomPadding = CSng(txtImageBottomPadding.Text)
            .ImageStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.GetRandomGeoColor(RandomColorType.Bright), GeoColor.SimpleColors.Black, 1)

         End If
         .TextLeftPadding = CSng(txtTextLeftPadding.Text)
         .TextTopPadding = CSng(txtTextTopPadding.Text)
         .TextBottomPadding = CSng(txtTextBottomPadding.Text)
         .TextRightPadding = CSng(txtTextRightPadding.Text)


         .TextStyle = New TextStyle(sText, New GeoFont("Arial", CInt(txtItemFontSize.Text)), New GeoSolidBrush(GeoColor.SimpleColors.Black))
         '.BackgroundMask = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Black, 1)

      End With

   End Sub
   Private Sub btn1_Click(sender As Object, e As System.EventArgs) Handles btnApply.Click
      mAddLegend()
   End Sub

   Private Sub frmLegendProps_Load(sender As Object, e As System.EventArgs) Handles Me.Load
      lstItems.Items.Clear()
      'With lstItems
      '   .Items.Add("States")
      '   .Items.Add("Counties")
      '   .Items.Add("Tracts")
      '   .Items.Add("Habitat Of Large and Slow Moving Wildebeasts")
      'End With

      For i As Integer = 1 To 10
         lstItems.Items.Add("I'm a lumberjack and I cut trees " & i.ToString)
      Next i


      Dim oLegendItem As New LegendItem

      With oLegendItem

         txtBottomPadding.Text = .BottomPadding.ToString
         txtTopPadding.Text = .TopPadding.ToString
         txtLeftPadding.Text = .LeftPadding.ToString
         txtRightPadding.Text = .RightPadding.ToString

         txtLegendItemHeight.Text = .Height.ToString
         txtImageBottomPadding.Text = .ImageBottomPadding.ToString
         txtImageHeight.Text = .ImageHeight.ToString
         txtImageLeftPadding.Text = .ImageLeftPadding.ToString
         txtImageRightPaddint.Text = .ImageRightPadding.ToString
         txtImageTopPadding.Text = .ImageTopPadding.ToString
         txtImageWidth.Text = .ImageWidth.ToString
         txtTextBottomPadding.Text = .TextBottomPadding.ToString
         txtTextLeftPadding.Text = .TextLeftPadding.ToString
         txtTextRightPadding.Text = .TextRightPadding.ToString
         txtTextTopPadding.Text = .TextTopPadding.ToString
      End With
      mAddLegend()
   End Sub

   Private Sub btnAddItem_Click(sender As System.Object, e As System.EventArgs) Handles btnAddItem.Click
      lstItems.Items.Add(txtItem.Text)
   End Sub

   Private Sub btnRemoveItem_Click(sender As System.Object, e As System.EventArgs) Handles btnRemoveItem.Click
      If lstItems.SelectedIndex <> -1 Then
         lstItems.Items.Remove(lstItems.SelectedItem.ToString)
      End If

   End Sub

   Private Sub btnCalcHeight_Click(sender As System.Object, e As System.EventArgs) Handles btnCalcHeight.Click
      Dim dHeight As Double

      If Not Legend Is Nothing Then
         dHeight = Legend.Title.Height + Legend.Title.TopPadding + Legend.Title.BottomPadding + 1
         For Each oItem As LegendItem In Legend.LegendItems
            dHeight += oItem.Height + oItem.TopPadding + oItem.BottomPadding + 1
         Next oItem
         txtCalcHeight.Text = dHeight.ToString
      End If
   End Sub
   Private Function mGetLegendHeight(ByVal oLegend As CustomLegendLayer) As Single
      Dim oGraphics As System.Drawing.Graphics = Me.CreateGraphics
      Dim oSizeF As SizeF
      Dim oLegendItem As LegendItem
      Dim dHeight As Single

      oGraphics.PageUnit = GraphicsUnit.Pixel
      oLegendItem = CType(oLegend.Title, LegendItem)
      oSizeF = oGraphics.MeasureString(oLegendItem.TextStyle.TextColumnName, FontFromGeoFont(oLegendItem.TextStyle.Font))
      dHeight = oSizeF.Height + oLegendItem.TextTopPadding + oLegendItem.BottomPadding

      For Each oLegendItem In oLegend.LegendItems
         oSizeF = oGraphics.MeasureString(oLegendItem.TextStyle.TextColumnName, FontFromGeoFont(oLegendItem.TextStyle.Font))
         dHeight += oSizeF.Height + oLegendItem.TextTopPadding + oLegendItem.BottomPadding
      Next oLegendItem

      Return dHeight
   End Function
   Private Function mGetLegendWidth(ByVal oLegend As LegendPrinterLayer) As Single
      Dim oGraphics As System.Drawing.Graphics = Me.CreateGraphics
      Dim dMaxWidth As Single = 0
      Dim dWidth As Single
      Dim oLegendItem As LegendItem
      Dim oWidestLegendItem As LegendItem
      Dim oSizeF As SizeF

      '***** Assume we're dealing in pixels
      oGraphics.PageUnit = GraphicsUnit.Pixel

      oWidestLegendItem = CType(oLegend.Title, LegendItem)
      With oWidestLegendItem
         oSizeF = oGraphics.MeasureString(.TextStyle.TextColumnName, FontFromGeoFont(.TextStyle.Font))
         dMaxWidth = oSizeF.Width + .ImageLeftPadding + .ImageRightPadding + .TextLeftPadding + .TextRightPadding + .LeftPadding + .RightPadding
         dMaxWidth = oSizeF.Width + .ImageLeftPadding + .ImageRightPadding
      End With


      For Each oLegendItem In oLegend.LegendItems
         With oLegendItem
            oSizeF = oGraphics.MeasureString(.TextStyle.TextColumnName, FontFromGeoFont(.TextStyle.Font))
            dWidth = oSizeF.Width + .ImageWidth + .ImageLeftPadding + .ImageRightPadding + .TextLeftPadding + .TextRightPadding + .LeftPadding + .RightPadding
            dWidth = oSizeF.Width + .ImageWidth + .ImageLeftPadding + .ImageRightPadding
         End With
         If dWidth > dMaxWidth Then
            dMaxWidth = dWidth
            oWidestLegendItem = oLegendItem
         End If
      Next oLegendItem

      oLegendItem = CType(oLegend.Title, LegendItem)
      oLegendItem.Width = dMaxWidth

      For Each oLegendItem In oLegend.LegendItems
         oLegendItem.Width = dMaxWidth
      Next oLegendItem

      Return dMaxWidth
   End Function

   Public Shared Function FontFromGeoFont(ByVal oGeoFont As GeoFont) As System.Drawing.Font
      Dim eGeoFontStyle As ThinkGeo.MapSuite.Core.DrawingFontStyles
      Dim eSystemFontStyle As System.Drawing.FontStyle
      Dim iFontStyles As Integer = 0

      eGeoFontStyle = oGeoFont.Style
      If (eGeoFontStyle And DrawingFontStyles.Regular) = DrawingFontStyles.Regular Then
         iFontStyles += FontStyle.Regular
      End If

      If (eGeoFontStyle And DrawingFontStyles.Bold) = DrawingFontStyles.Bold Then
         iFontStyles += FontStyle.Bold
      End If

      If (eGeoFontStyle And DrawingFontStyles.Italic) = DrawingFontStyles.Italic Then
         iFontStyles += FontStyle.Italic
      End If

      If (eGeoFontStyle And DrawingFontStyles.Underline) = DrawingFontStyles.Underline Then
         iFontStyles += FontStyle.Underline
      End If

      eSystemFontStyle = CType(iFontStyles, System.Drawing.FontStyle)

      With oGeoFont

         Dim oFont As New System.Drawing.Font(.FontName, .Size, eSystemFontStyle)
         Return oFont
      End With


   End Function

End Class